Description

Currently CoCoA-5 accepts juxtaposed string literals (i.e. separated by nothing or white space).

Can we remove this "feature?  What was the original reason for wanting this?  Is it still valid?

Related issues:

Related to CoCoA-5 - Bug #182: Unescaped double quote inside superstring Closed 08 Jun 2012

Related to CoCoA-5 - Slug #875: Interpreter is too slow reading a big polynomial In Progress 03 May 2016

Related to CoCoA-5 - Feature #1431: Juxtaposition of string literals Rejected 03 Mar 2020

History

#1 - 25 Jun 2014 16:50 - Anna Maria Bigatti

Can we remove this "feature? What was the original reason for wanting this?

 

The original reason was to allow it because it exists in C/C++.

Was not a cocoa-4 valid syntax.

Remove it!

#2 - 25 Jun 2014 17:04 - John Abbott

- Status changed from New to In Progress

- Assignee set to John Abbott

- % Done changed from 0 to 20

I believe the relevant source is in Parser.C lines 2095-2103 inclusive.

I'll try commenting out, and see if everything still works...

#3 - 25 Jun 2014 19:16 - John Abbott

- % Done changed from 20 to 60

I tried; it compiled and all tests pass.  Will test more tomorrow, and then check in.

#4 - 26 Jun 2014 12:12 - John Abbott

Here is a possible reason for wanting to allow juxtaposition of strings: if an input includes a very long string literal, that literal could be split over
several lines.  The unification of the literals occurs inside the parser -- there is no run-time cost (but then who would put a large string literal inside a

loop???) unlike an explicit use of + to concatenate them at run-time.

However, I cannot think of any plausible situation where CoCoA-5 code might want to have very long string literals.  Conversely, an input with very

long integer literals is quite likely, but we have no mechanism for splitting those!

All in all, it really does seem to be a "useless" feature...

#5 - 26 Jun 2014 12:27 - Anna Maria Bigatti

All in all, it really does seem to be a "useless" feature...

 

and was not in CoCoA-4.  It's a pointless exception.

#6 - 26 Jun 2014 15:33 - John Abbott

- Status changed from In Progress to Closed

- % Done changed from 60 to 100

If there were any serious problems, they'd have come to light by now (almost 24 hours of testing!)

Closing.

#7 - 06 Jun 2016 23:50 - John Abbott

- Related to Slug #875: Interpreter is too slow reading a big polynomial added

#8 - 03 Mar 2020 15:30 - John Abbott

- Related to Feature #1431: Juxtaposition of string literals added
